/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2016 by 3rd Designing Center
 *              Imageing System Development Division RICOH COMPANY, LTD.
 *  Copyright (C) 2017-2020 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_serial.h 698 2020-02-23 16:43:41Z roi $
 */

/*
 *    ꥢI/OǥХSIO˥ɥ饤
 */

#ifndef TOPPERS_TARGET_SERIAL_H
#define TOPPERS_TARGET_SERIAL_H

/*
 *  åװ¸⥸塼stm32f767-nucleo144ѡ
 */

/*
 *  SIOGPIO
 */
#define TADR_U1T_GPIO_BASE TADR_GPIOD_BASE
#define TADR_U1R_GPIO_BASE TADR_GPIOD_BASE
#define TADR_U2T_GPIO_BASE TADR_GPIOG_BASE
#define TADR_U2R_GPIO_BASE TADR_GPIOG_BASE
#define TOFF_U1_APBNER     TOFF_RCC_APB1ENR
#define TOFF_U2_APBNER     TOFF_RCC_APB2ENR
#define TOFF_U1_APBRSTR    TOFF_RCC_APB1RSTR
#define TOFF_U2_APBRSTR    TOFF_RCC_APB2RSTR
#define GPIO_U1_AF         0x07
#define GPIO_U2_AF         0x08
#define ENABLE_U1_PORT     RCC_APB1ENR_USART3EN
#define ENABLE_U2_PORT     RCC_APB2ENR_USART6EN
#define ENABLE_U1T_GPIO    RCC_AHB1ENR_GPIODEN
#define ENABLE_U1R_GPIO    RCC_AHB1ENR_GPIODEN
#define ENABLE_U2T_GPIO    RCC_AHB1ENR_GPIOGEN
#define ENABLE_U2R_GPIO    RCC_AHB1ENR_GPIOGEN
#define RESET_U1_PORT      RCC_APB1RSTR_USART3RST
#define RESET_U2_PORT      RCC_APB2RSTR_USART6RST
#define TX1_PINPOS         8
#define RX1_PINPOS         9
#define TX2_PINPOS         14
#define RX2_PINPOS         9

/*
 *  SIOΥ١ɥ쥹
 */
#define USART1_BASE        TADR_USART3_BASE
#define USART2_BASE        TADR_USART6_BASE

/*
 *  CLOCK
 */
#define U1_CLOCK_SHIFT     4
#define U2_CLOCK_SHIFT     10

/*
 *  ꥢI/Oݡȿ
 */
#ifndef TNUM_SIOP
#define TNUM_SIOP       2       /* ݡȤ륷ꥢI/OݡȤο */
#endif

/*
 *  SIOγߥϥɥΥ٥ֹ
 */
#define INHNO_SIO1      IRQ_VECTOR_USART3
#define INTNO_SIO1      IRQ_VECTOR_USART3
#define INHNO_SIO2      IRQ_VECTOR_USART6
#define INTNO_SIO2      IRQ_VECTOR_USART6

#define INTPRI_SIO       -3        /* ͥ */
#define INTATR_SIO       0         /* ° */


#include "arm_m_gcc/stm32f7xx/chip_serial.h"

#endif /* TOPPERS_TARGET_SERIAL_H */
