/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2016 by 3rd Designing Center
 *              Imageing System Development Division RICOH COMPANY, LTD.
 *  Copyright (C) 2017-2017 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_syssvc.h 698 2017-02-05 16:47:09Z roi $
 */

/*
 *  ƥॵӥΥåȰ¸stm32f767-nucleo144ѡ
 *
 *  ƥॵӥΥåȰ¸Υ󥯥롼ɥե롥Υե
 *  Ƥϡݡͥȵҥե˵Ҥ졤Υե
 *  ̵ʤ븫ߡ
 */

#ifndef TOPPERS_TARGET_SYSSVC_H
#define TOPPERS_TARGET_SYSSVC_H

/*
 *  åȥƥΥϡɥ񸻤
 */
#include "stm32f7xx.h"

/*
 *  ƥ९å
 */
#define SystemFrequency     216000000
#define SysFreHCLK          216000000	/* HCLK = MasterClock / 1 */
#define SysFrePCLK1         54000000	/* PCLK1 = HCLK / 4 */
#define SysFrePCLK2         108000000	/* PCLK2 = HCLK / 2 */
#define HSE_VALUE           8000000
#define HSI_VALUE           16000000
#define LSE_VALUE           32768

#define SYS_CLOCK		    (SystemFrequency)

/*
 *  ȥ졼˴ؤ
 */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  ưåΥåȥƥ̾
 */
#define TARGET_NAME    "stm32f767-nucleo144(Cortex-M7)"

/*
 *  ưåɽ
 */
#define TARGET_COPYRIGHT \
"Copyright (C) 2015-2017 by Education Working Group TOPPERS PROJECT, JAPAN\n" \

/*
 *  ƥ٥ϤΤʸ
 *
 *  åȰ¸ˡǡʸcɽ//¸롥
 */
extern void	target_fput_log(int8_t c);

/*
 *  ݡȤ륷ꥢݡȤο
 */
#define TNUM_PORT        TNUM_SIOP

/*
 *  ѤݡID
 */
#define LOGTASK_PORTID   SIO_PORTID

/*
 *  ܡ졼
 */
#define BPS_SETTING		(115200)

/*
 *  ƥϢ
 *
 *  ǥե̤ͤꡥ
 */

#endif /* TOPPERS_TARGET_SYSSVC_H */
